diff --git a/game/core/src/main/java/net/minecraft/core/block/FluidWater.java b/game/core/src/main/java/net/minecraft/core/block/FluidWater.java
index e5f90874f..b54916f82 100644
--- a/game/core/src/main/java/net/minecraft/core/block/FluidWater.java
+++ b/game/core/src/main/java/net/minecraft/core/block/FluidWater.java
@@ -1,42 +1,43 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
 public class FluidWater
-    implements Fluid
-{
+    implements Fluid {
     @Override
     public int tickDelay() {
         return 5;
     }
 
     @Override
-    public void animationTick(final @NotNull BlockLogicFluid logicFluid, final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Random rand) {
+    public void animationTick(final @NotNull BlockLogicFluid logicFluid, final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand) {
         final int data = world.getBlockData(tilePos) & 0x0F;
-        TilePos up = tilePos.up();
-        final boolean isTop = world.getBlockMaterial(up) == Material.air && !world.isBlockOpaqueCube(up);
+        TilePos up = tilePos.up(new TilePos());
+        final boolean isTop = world.getBlockMaterial(up) == Materials.AIR && !world.isBlockOpaqueCube(up);
         if (rand.nextInt(64) == 0) {
             if (data > 0 && data < 8) {
-                world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (float) tilePos.x + 0.5F, (float) tilePos.y + 0.5F, (float) tilePos.z + 0.5F, "liquid.water", rand.nextFloat() * 0.25F + 0.75F, rand.nextFloat() * 1.0F + 0.5F);
+                world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (float) tilePos.x() + 0.5F, (float) tilePos.y() + 0.5F, (float) tilePos.z() + 0.5F, "liquid.water", rand.nextFloat() * 0.25F + 0.75F, rand.nextFloat() * 1.0F + 0.5F);
             }
         }
         if (world.dimension == Dimension.NETHER && isTop && data == 0 && rand.nextInt(4) == 0) {
-            world.spawnParticle("smoke", tilePos.x + Math.random(), tilePos.y + (14f / 16f), tilePos.z + Math.random(), 0.0D, 0.0D, 0.0D, 1);
+            world.spawnParticle("smoke", tilePos.x() + Math.random(), tilePos.y() + (14f / 16f), tilePos.z() + Math.random(), 0.0D, 0.0D, 0.0D, 1);
         }
 
     }
 
     @Override
-    public void checkForHarden(final @NotNull BlockLogicFluid logicFluid, final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Material encountered) {
-        if (encountered == Material.lava) {
+    public void checkForHarden(final @NotNull BlockLogicFluid logicFluid, final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Material encountered) {
+        if (encountered == Materials.LAVA) {
             final int data = world.getBlockData(tilePos) & 0x0F;
             if (data == 0) {
                 world.setBlockIdNotify(tilePos, Blocks.COBBLE_LIMESTONE.id());
@@ -51,17 +52,17 @@ public class FluidWater
     }
 
     @Override
-    public void updateTickStill(final @NotNull BlockLogicFluid logicFluid, final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Random rand) {
+    public void updateTickStill(final @NotNull BlockLogicFluid logicFluid, final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand) {
         // Do nothing
     }
 
     @Override
-    public byte getFlowDecayMod(final @NotNull BlockLogicFluid logicFluid, final @NotNull World world, final @NotNull TilePos tilePos) {
+    public byte getFlowDecayMod(final @NotNull BlockLogicFluid logicFluid, final @NotNull World world, final @NotNull TilePosc tilePos) {
         return 1;
     }
 
     @Override
-    public boolean canBecomeSource(final @NotNull BlockLogicFluid logicFluid, final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Random rand) {
+    public boolean canBecomeSource(final @NotNull BlockLogicFluid logicFluid, final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand) {
         return world.dimension != Dimension.NETHER;
     }
 
@@ -75,6 +76,6 @@ public class FluidWater
 
     @Override
     public boolean canSpreadTo(final @NotNull BlockLogicFluid logicFluid, final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Material material) {
-        return material != Material.lava;
+        return material != Materials.LAVA;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/IPaintable.java b/game/core/src/main/java/net/minecraft/core/block/IPaintable.java
index d6197584e..b88ea416a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/IPaintable.java
+++ b/game/core/src/main/java/net/minecraft/core/block/IPaintable.java
@@ -3,12 +3,13 @@ package net.minecraft.core.block;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 public interface IPaintable {
     default boolean canBePainted() { return true; }
 
-    void setColor(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull DyeColor color);
+    void setColor(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull DyeColor color);
 
     @Deprecated
     default void setColor(final @NotNull World world, final int x, final int y, final int z, final @NotNull DyeColor color) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/IPainted.java b/game/core/src/main/java/net/minecraft/core/block/IPainted.java
index 1d76f6781..d0fa3b7de 100644
--- a/game/core/src/main/java/net/minecraft/core/block/IPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/IPainted.java
@@ -3,6 +3,7 @@ package net.minecraft.core.block;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 public interface IPainted
@@ -13,14 +14,14 @@ public interface IPainted
 
     int stripColorFromMetadata(int meta);
 
-    void removeDye(final @NotNull World world, final @NotNull TilePos tilePos);
+    void removeDye(final @NotNull World world, final @NotNull TilePosc tilePos);
 
     @Deprecated
     default void removeDye(final @NotNull World world, final int x, final int y, final int z) {
         this.removeDye(world, new TilePos(x, y, z));
     }
 
-    default @NotNull DyeColor getColor(final @NotNull World world, final @NotNull TilePos tilePos) {
+    default @NotNull DyeColor getColor(final @NotNull World world, final @NotNull TilePosc tilePos) {
         return this.fromMetadata(world.getBlockData(tilePos));
     }
 
@@ -30,7 +31,7 @@ public interface IPainted
     }
 
     @Override
-    default void setColor(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull DyeColor color) {
+    default void setColor(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull DyeColor color) {
         final int data = world.getBlockData(tilePos);
         world.setBlockDataNotify(tilePos, this.stripColorFromMetadata(data) | this.toMetadata(color));
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
index cd3486e9c..1944ba820 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
@@ -19,20 +19,19 @@ import com.mojang.nbt.tags.ListTag;
 import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.net.packet.PacketTileEntityData;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.ICarriable;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
-public class TileEntityBasket extends TileEntity
-{
+public class TileEntityBasket extends TileEntity {
     private int numUnitsInside = 0;
     private final Object2IntMap<BasketEntry> contents = new Object2IntArrayMap<>();
 
-    private void updateNumUnits()
-    {
+    private void updateNumUnits() {
         int currentNumInside = calcNumUnitsInside();
-        if (currentNumInside != numUnitsInside && worldObj != null){
+        if (currentNumInside != numUnitsInside && worldObj != null) {
             this.numUnitsInside = currentNumInside;
             worldObj.notifyBlockChange(x, y, z, worldObj.getBlockId(x, y, z));
             setChanged();
@@ -41,8 +40,7 @@ public class TileEntityBasket extends TileEntity
 
     private int calcNumUnitsInside() {
         int numInside = 0;
-        for (Map.Entry<BasketEntry, Integer> entry : contents.object2IntEntrySet())
-        {
+        for (Map.Entry<BasketEntry, Integer> entry : contents.object2IntEntrySet()) {
             final BasketEntry be = entry.getKey();
             final int numItems = entry.getValue();
 
@@ -52,14 +50,12 @@ public class TileEntityBasket extends TileEntity
         return numInside;
     }
 
-    private int getItemSizeUnits(final Item item)
-    {
+    private int getItemSizeUnits(final Item item) {
         return 64 / item.getItemStackLimit(null);
     }
 
 
-    private void dropItemStack(final Random rand, final ItemStack itemstack)
-    {
+    private void dropItemStack(final Random rand, final ItemStack itemstack) {
         final float f = rand.nextFloat() * 0.8F + 0.1F;
         final float f1 = rand.nextFloat() * 0.8F + 0.1F;
         final float f2 = rand.nextFloat() * 0.8F + 0.1F;
@@ -81,46 +77,43 @@ public class TileEntityBasket extends TileEntity
         workingWorld.entityJoinedWorld(item);
     }
 
-    public int getNumUnitsInside()
-    {
+    public int getNumUnitsInside() {
         return this.numUnitsInside;
     }
 
-    public int getMaxUnits()
-    {
+    public int getMaxUnits() {
         return 27 * 64;
     }
 
-	public void givePlayerAllItems(final World world, final Player player) {
-		final List<BasketEntry> toRemove = new ArrayList<>();
+    public void givePlayerAllItems(final World world, final Player player) {
+        final List<BasketEntry> toRemove = new ArrayList<>();
 
-		for(final Object2IntMap.Entry<BasketEntry> entry : this.contents.object2IntEntrySet()) {
-			final BasketEntry basketEntry = entry.getKey();
-			final ItemStack basketEntryStack = new ItemStack(basketEntry.id, entry.getIntValue(), basketEntry.metadata, basketEntry.tag);
-			// Beware! basketEntryStack may have a stack size higher than its limit!
-			
-			player.inventory.insertItem(basketEntryStack, true);
+        for (final Object2IntMap.Entry<BasketEntry> entry : this.contents.object2IntEntrySet()) {
+            final BasketEntry basketEntry = entry.getKey();
+            final ItemStack basketEntryStack = new ItemStack(basketEntry.id, entry.getIntValue(), basketEntry.metadata, basketEntry.tag);
+            // Beware! basketEntryStack may have a stack size higher than its limit!
+
+            player.inventory.insertItem(basketEntryStack, true);
             this.contents.put(basketEntry, basketEntryStack.stackSize);
-			
-			if(basketEntryStack.stackSize <= 0) {
-				toRemove.add(basketEntry);
-			}
-		}
 
-		for(final BasketEntry entry : toRemove) {
+            if (basketEntryStack.stackSize <= 0) {
+                toRemove.add(basketEntry);
+            }
+        }
+
+        for (final BasketEntry entry : toRemove) {
             this.contents.removeInt(entry);
-		}
+        }
 
-		updateNumUnits();
+        updateNumUnits();
         world.notifyBlockChange(this.x, this.y, this.z, Blocks.BASKET.id());
-	}
+    }
 
     @Override
     public void readAdditionalData(@NotNull final CompoundTag compoundTag) {
         final ListTag itemsTag = compoundTag.getList("Items");
         this.contents.clear();
-        for (int i = 0; i < itemsTag.tagCount(); i++)
-        {
+        for (int i = 0; i < itemsTag.tagCount(); i++) {
             final CompoundTag itemTag = (CompoundTag) itemsTag.tagAt(i);
             final BasketEntry entry = BasketEntry.read(itemTag);
             final int count = itemTag.getShort("Count");
@@ -130,8 +123,7 @@ public class TileEntityBasket extends TileEntity
     }
 
     @Override
-    public void tick()
-    {
+    public void tick() {
         if (this.worldObj != null && this.worldObj.isClientSide) return;
         if (this.carriedBlock != null && this.carriedBlock.world.isClientSide) return;
 
@@ -153,14 +145,13 @@ public class TileEntityBasket extends TileEntity
             return;
         }
 
-        final AABB aabb = AABB.fromPool(posX, posY, posZ, posX + 1, posY + 2, posZ + 1);
+        final AABBdc aabb = new AABBd(posX, posY, posZ, posX + 1, posY + 2, posZ + 1);
 
         final List<EntityItem> entities = workingWorld.getEntitiesWithinAABB(EntityItem.class, aabb);
 
         boolean shouldUpdate = false;
 
-        if (!entities.isEmpty())
-        {
+        if (!entities.isEmpty()) {
             for (int i = 0; i < entities.size(); i++) {
                 if (calcNumUnitsInside() >= getMaxUnits()) break;
                 EntityItem e = entities.get(i);
@@ -174,8 +165,7 @@ public class TileEntityBasket extends TileEntity
             }
         }
 
-        if (shouldUpdate)
-        {
+        if (shouldUpdate) {
             if (this.worldObj != null) {
                 this.worldObj.notifyBlockChange(this.x, this.y, this.z, Blocks.BASKET.id());
             }
@@ -183,8 +173,7 @@ public class TileEntityBasket extends TileEntity
         }
     }
 
-    private boolean importItemStack(final ItemStack stack)
-    {
+    private boolean importItemStack(final ItemStack stack) {
         BasketEntry entry = new BasketEntry(stack.itemID, stack.getMetadata(), stack.getData());
         final int sizeUnits = getItemSizeUnits(stack.getItem());
         final int freeUnits = getMaxUnits() - numUnitsInside;
@@ -198,11 +187,9 @@ public class TileEntityBasket extends TileEntity
     }
 
     @Override
-    public void writeAdditionalData(@NotNull final CompoundTag compoundTag)
-    {
+    public void writeAdditionalData(@NotNull final CompoundTag compoundTag) {
         final ListTag itemsTag = new ListTag();
-        for (final Object2IntMap.Entry<BasketEntry> entry : this.contents.object2IntEntrySet())
-        {
+        for (final Object2IntMap.Entry<BasketEntry> entry : this.contents.object2IntEntrySet()) {
             final CompoundTag itemTag = new CompoundTag();
             itemTag.putShort("Count", (short) entry.getIntValue());
             BasketEntry.write(itemTag, entry.getKey());
@@ -226,13 +213,11 @@ public class TileEntityBasket extends TileEntity
         super.dropContents(world, x, y, z);
         final Random rand = new Random();
 
-        for (final Object2IntMap.Entry<BasketEntry> entry : this.contents.object2IntEntrySet())
-        {
+        for (final Object2IntMap.Entry<BasketEntry> entry : this.contents.object2IntEntrySet()) {
             final BasketEntry be = entry.getKey();
             int numItems = entry.getIntValue();
 
-            while (numItems > 0)
-            {
+            while (numItems > 0) {
                 final int maxStackSize = be.getItem().getItemStackLimit(null);
                 int stackSize = maxStackSize;
                 final int remainingItems = numItems - maxStackSize;
@@ -252,26 +237,24 @@ public class TileEntityBasket extends TileEntity
     public void heldTick(final World world, final Entity holder) {
         tick();
     }
+
     @Override
     public boolean canBeCarried(final World world, final Entity potentialHolder) {
         return true;
     }
 
-    private static final class BasketEntry
-    {
+    private static final class BasketEntry {
         public final int id;
         public final int metadata;
         public final CompoundTag tag;
 
-        public BasketEntry(final int id, final int metadata, final CompoundTag tag)
-        {
+        public BasketEntry(final int id, final int metadata, final CompoundTag tag) {
             this.id = id;
             this.metadata = metadata;
             this.tag = tag;
         }
 
-        public static BasketEntry read(final CompoundTag tag)
-        {
+        public static BasketEntry read(final CompoundTag tag) {
             final int id = tag.getShort("id");
             final int damage = tag.getShort("Damage");
             final CompoundTag data = tag.getCompound("Data");
@@ -279,21 +262,18 @@ public class TileEntityBasket extends TileEntity
             return new BasketEntry(id, damage, data);
         }
 
-        public static void write(final CompoundTag tag, final BasketEntry entry)
-        {
+        public static void write(final CompoundTag tag, final BasketEntry entry) {
             tag.putShort("id", (short) entry.id);
             tag.putShort("Damage", (short) entry.metadata);
             tag.putCompound("Data", entry.tag);
         }
 
-        public Item getItem()
-        {
+        public Item getItem() {
             return Item.itemsList[this.id];
         }
 
         @Override
-        public boolean equals(final Object obj)
-        {
+        public boolean equals(final Object obj) {
             if (!(obj instanceof BasketEntry)) return false;
             final BasketEntry other = (BasketEntry) obj;
             if (this.id != other.id || this.metadata != other.metadata) return false;
@@ -301,14 +281,10 @@ public class TileEntityBasket extends TileEntity
         }
 
         @Override
-        public int hashCode()
-        {
-            if (this.tag.getValues().size() <= 2)
-            {
+        public int hashCode() {
+            if (this.tag.getValues().size() <= 2) {
                 return Objects.hash(this.id, this.metadata);
-            }
-            else
-            {
+            } else {
                 return Objects.hash(this.id, this.metadata, this.tag);
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
index 821bfb1de..3ba382720 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
@@ -4,16 +4,16 @@ import com.mojang.logging.LogUtils;
 import net.minecraft.core.entity.EntityDispatcher;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.util.helper.MathHelper;
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.net.packet.PacketSetMobSpawner;
 import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
+import org.joml.primitives.AABBd;
 import org.slf4j.Logger;
 
-public class TileEntityMobSpawner extends TileEntity
-{
+public class TileEntityMobSpawner extends TileEntity {
     private static final Logger LOGGER = LogUtils.getLogger();
     public int delay;
     private String mobId;
@@ -21,25 +21,22 @@ public class TileEntityMobSpawner extends TileEntity
     public double yaw2;
     private int nearby;
 
-    public TileEntityMobSpawner()
-    {
-        yaw2 = 0.0D;
-        mobId = "minecraft:pig";
-        delay = 20;
+    public TileEntityMobSpawner() {
+        this.yaw2 = 0.0D;
+        this.mobId = "minecraft:pig";
+        this.delay = 20;
     }
 
-    public String getMobId()
-    {
-        return mobId;
+    public String getMobId() {
+        return this.mobId;
     }
 
-    public void setMobId(String mobId)
-    {
-    	if(mobId != null && mobId.equalsIgnoreCase("none")) {
-    		this.mobId = null;
-    	} else {
-    		this.mobId = mobId;
-    	}
+    public void setMobId(String mobId) {
+        if (mobId != null && mobId.equalsIgnoreCase("none")) {
+            this.mobId = null;
+        } else {
+            this.mobId = mobId;
+        }
         try {
             if (EntityDispatcher.Legacy.isLegacyKey(mobId)) {
                 EntityDispatcher.EntityDispatcherEntry<?> entry = EntityDispatcher.getInstance().entryForClass(EntityDispatcher.Legacy.getClassFromEncodeID(mobId));
@@ -50,84 +47,75 @@ public class TileEntityMobSpawner extends TileEntity
         }
     }
 
-    public boolean anyPlayerInRange()
-    {
-        return worldObj != null && worldObj.getClosestPlayer((double) x + 0.5D, (double) y + 0.5D, (double) z + 0.5D, 16D) != null;
+    public boolean anyPlayerInRange() {
+        return this.worldObj != null && this.worldObj.getClosestPlayer((double) this.x + 0.5D, (double) this.y + 0.5D, (double) this.z + 0.5D, 16D) != null;
     }
 
     @Override
-	public void tick()
-    {
-        if (worldObj.getBlockId(x, y, z) != Blocks.MOBSPAWNER.id()) return; // dumb fix for mp particle bug, need proper way to inform client to remove tileEntity
-        yaw2 = yaw;
-        if(!anyPlayerInRange())
-        {
+    public void tick() {
+        if (this.worldObj.getBlockId(this.x, this.y, this.z) != Blocks.MOBSPAWNER.id())
+            return; // dumb fix for mp particle bug, need proper way to inform client to remove tileEntity
+        this.yaw2 = this.yaw;
+        if (!anyPlayerInRange()) {
             return;
         }
-        double xPos = (double) x + worldObj.rand.nextFloat();
-        double yPos = (double) y + worldObj.rand.nextFloat();
-        double zPos = (double) z + worldObj.rand.nextFloat();
-        worldObj.spawnParticle("smoke", xPos, yPos, zPos, 0.0D, 0.0D, 0.0D, 0);
-        worldObj.spawnParticle("flame", xPos, yPos, zPos, 0.0D, 0.0D, 0.0D, 0);
-        for(yaw += 1000F / ((float)delay + 200F); yaw > 360D;)
-        {
-            yaw -= 360D;
-            yaw2 -= 360D;
+        double xPos = (double) this.x + this.worldObj.rand.nextFloat();
+        double yPos = (double) this.y + this.worldObj.rand.nextFloat();
+        double zPos = (double) this.z + this.worldObj.rand.nextFloat();
+        this.worldObj.spawnParticle("smoke", xPos, yPos, zPos, 0.0D, 0.0D, 0.0D, 0);
+        this.worldObj.spawnParticle("flame", xPos, yPos, zPos, 0.0D, 0.0D, 0.0D, 0);
+        for (this.yaw += 1000F / ((float) this.delay + 200F); this.yaw > 360D; ) {
+            this.yaw -= 360D;
+            this.yaw2 -= 360D;
         }
 
-        if(!worldObj.isClientSide)
-        {
-        	if(!worldObj.getDifficulty().canHostileMobsSpawn()) {
-        		return;
-        	}
-        	if(mobId == null || mobId.equalsIgnoreCase("none")) {
-        		return;
-        	}
-            if(delay == -1)
-            {
+        if (!this.worldObj.isClientSide) {
+            if (!this.worldObj.getDifficulty().canHostileMobsSpawn()) {
+                return;
+            }
+            if (this.mobId == null || this.mobId.equalsIgnoreCase("none")) {
+                return;
+            }
+            if (this.delay == -1) {
                 updateDelay();
             }
-            if(delay > 0)
-            {
-                delay--;
+            if (this.delay > 0) {
+                this.delay--;
                 return;
             }
-            if(mobId == null) {
-            	nearby = countNearbySpawners();
+            if (this.mobId == null) {
+                this.nearby = countNearbySpawners();
             }
             byte byte0 = 4;
-            for(int i = 0; i < byte0; i++)
-            {
-                Mob mob = (Mob) EntityDispatcher.getInstance().createEntityInWorld(mobId, worldObj);
+            for (int i = 0; i < byte0; i++) {
+                Mob mob = (Mob) EntityDispatcher.getInstance().createEntityInWorld(this.mobId, this.worldObj);
 
-                if(mob == null)
-                {
+                if (mob == null) {
                     return;
                 }
-                int j = worldObj.getEntitiesWithinAABB(mob.getClass(), AABB.fromPool(x, y, z, x + 1, y + 1, z + 1).grow(8D, 4D, 8D)).size();
-                if(j >= 6)
-                {
+                AABBd checkBB = new AABBd(this.x, this.y, this.z, this.x + 1, this.y + 1, this.z + 1);
+                MathHelper.aabbGrow(checkBB, 8, 4, 8, checkBB);
+                int nearbySpawnCount = this.worldObj.getEntitiesWithinAABB(mob.getClass(), checkBB).size();
+                if (nearbySpawnCount >= 6) {
                     updateDelay();
                     return;
                 }
-                double d6 = (double) x + (worldObj.rand.nextDouble() - worldObj.rand.nextDouble()) * 4D;
-                double d7 = (y + worldObj.rand.nextInt(3)) - 1;
-                double d8 = (double) z + (worldObj.rand.nextDouble() - worldObj.rand.nextDouble()) * 4D;
-                mob.moveTo(d6, d7, d8, worldObj.rand.nextFloat() * 360F, 0.0F);
-                if(!mob.canSpawnHere())
-                {
-                	updateDelay();
+                double d6 = (double) this.x + (this.worldObj.rand.nextDouble() - this.worldObj.rand.nextDouble()) * 4D;
+                double d7 = (this.y + this.worldObj.rand.nextInt(3)) - 1;
+                double d8 = (double) this.z + (this.worldObj.rand.nextDouble() - this.worldObj.rand.nextDouble()) * 4D;
+                mob.moveTo(d6, d7, d8, this.worldObj.rand.nextFloat() * 360F, 0.0F);
+                if (!mob.canSpawnHere()) {
+                    updateDelay();
                     continue;
                 }
-                worldObj.entityJoinedWorld(mob);
-                for(int k = 0; k < 20; k++)
-                {
-                    double d1 = (double) x + 0.5D + ((double)worldObj.rand.nextFloat() - 0.5D) * 2D;
-                    double d3 = (double) y + 0.5D + ((double)worldObj.rand.nextFloat() - 0.5D) * 2D;
-                    double d5 = (double) z + 0.5D + ((double)worldObj.rand.nextFloat() - 0.5D) * 2D;
-                    worldObj.spawnParticle("smoke", d1, d3, d5, 0.0D, 0.0D, 0.0D, 0);
-                    worldObj.spawnParticle("flame", d1, d3, d5, 0.0D, 0.0D, 0.0D, 0);
-                    worldObj.playSoundAtEntity(null, mob, "tile.mobspawner.spawn", 0.025F, 0.75F);
+                this.worldObj.entityJoinedWorld(mob);
+                for (int k = 0; k < 20; k++) {
+                    double d1 = (double) this.x + 0.5D + ((double) this.worldObj.rand.nextFloat() - 0.5D) * 2D;
+                    double d3 = (double) this.y + 0.5D + ((double) this.worldObj.rand.nextFloat() - 0.5D) * 2D;
+                    double d5 = (double) this.z + 0.5D + ((double) this.worldObj.rand.nextFloat() - 0.5D) * 2D;
+                    this.worldObj.spawnParticle("smoke", d1, d3, d5, 0.0D, 0.0D, 0.0D, 0);
+                    this.worldObj.spawnParticle("flame", d1, d3, d5, 0.0D, 0.0D, 0.0D, 0);
+                    this.worldObj.playSoundAtEntity(null, mob, "tile.mobspawner.spawn", 0.025F, 0.75F);
                 }
 
                 mob.spawnExplosionParticle();
@@ -137,54 +125,51 @@ public class TileEntityMobSpawner extends TileEntity
         }
         super.tick();
     }
-    
+
     @Override
-	public Packet getDescriptionPacket()
-    {
-        return new PacketSetMobSpawner(new TilePos(x, y, z), EntityDispatcher.getInstance().entryForId(mobId));
+    public Packet getDescriptionPacket() {
+        return new PacketSetMobSpawner(new TilePos(this.x, this.y, this.z), EntityDispatcher.getInstance().entryForId(this.mobId));
     }
-    
+
     public int countNearbySpawners() {
-    	int r = 4;
-    	int count = 0;
-    	for(int i = -r; i <= r; i++) {
-    		for(int j = -r; j <= r; j++) {
-    			for(int k = -r; k <= r; k++) {
-    				int id = worldObj.getBlockId(x + i, y + j, z + k);
-    				if(id == Blocks.MOBSPAWNER.id()) {
-    					count++;
-    				}
-    			}
-    		}
-    	}
-    	return count;
+        int r = 4;
+        int count = 0;
+        TilePos tilePos = new TilePos(0, 0, 0);
+        for (tilePos.x = this.x -r; tilePos.x <= this.x + r; tilePos.x++) {
+            for (tilePos.y = this.y -r; tilePos.y <= this.y + r; tilePos.y++) {
+                for (tilePos.z = this.z -r; tilePos.z <= this.z + r; tilePos.z++) {
+                    int id = this.worldObj.getBlockId(tilePos);
+                    if (id == Blocks.MOBSPAWNER.id()) {
+                        count++;
+                    }
+                }
+            }
+        }
+        return count;
     }
 
-    private void updateDelay()
-    {
-    	delay = 200 + worldObj.rand.nextInt(600);
-    	if(mobId == null) {
-    		delay *= 2;
+    private void updateDelay() {
+        this.delay = 200 + this.worldObj.rand.nextInt(600);
+        if (this.mobId == null) {
+            this.delay *= 2;
             LOGGER.debug("x2");
-    		if(nearby > 1) {
+            if (this.nearby > 1) {
                 LOGGER.debug("x4");
-    			delay *= 4;
-    		}
-    	}
+                this.delay *= 4;
+            }
+        }
     }
 
     @Override
-    public void readAdditionalData(@NotNull CompoundTag compoundTag)
-    {
+    public void readAdditionalData(@NotNull CompoundTag compoundTag) {
         setMobId(compoundTag.getString("EntityId"));
-        delay = compoundTag.getShort("Delay");
+        this.delay = compoundTag.getShort("Delay");
     }
 
     @Override
-    public void writeAdditionalData(@NotNull CompoundTag compoundTag)
-    {
-        compoundTag.putString("EntityId", mobId != null ? mobId : "none");
-        compoundTag.putShort("Delay", (short)delay);
+    public void writeAdditionalData(@NotNull CompoundTag compoundTag) {
+        compoundTag.putString("EntityId", this.mobId != null ? this.mobId : "none");
+        compoundTag.putShort("Delay", (short) this.delay);
     }
 
 }
